MIN_SUN_HOURS = new Array(8, 16); // vychod (h), zapad (h) - vychod a zapad slunce k 1.1. (nejkratsi den)
MAX_SUN_HOURS = new Array(4, 20); // vychod (h), zapad (h) - vychod a zapad slunce k 1.7. (nedelsi den)

SUNRISE_DURATION = 2; // doba rychleho vychodu / zapadu slunce (h)
DAYS_IN_MONTH = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);

SKY_DAY = new Array();
SKY_DAY[0] = new Array(0.1, 0.1, 0.5); // r, g, b
SKY_DAY[1] = new Array(0.2, 0.2, 0.6); // r, g, b
SKY_DAY[2] = new Array(0.6, 0.6, 0.7); // r, g, b

/**
 * Intervaly se nastavuji za behu.
 */
TOTAL_DARK_INTERVAL = new Array(0, 0); // od (h) do (h)
TOTAL_LIGHT_INTERVAL = new Array(0, 0); // od (h) do (h)

TOTAL_DARK_KOEF = new Array(0.1, 0.2) // absolutni tma (intensity 0-1), krajni tma (0-1)
TOTAL_LIGHT_KOEF = new Array(1.0, 0.9) // absolutni svetlo (intensity 0-1), krajni svetlo (0-1)

// defaultni nastaveni outputu - nastavene inverzne, nez chci defaul;tni, protoze
// po nacteni skriptu poustim mzmenu, abz se mi nastavily barvy apod.
mesto_duchu = true;
sipky = 0;
cas = false;
lod = 0;

// zda byl zmenen den - kvuli tomu, abz se porad zbytecne nepocitala delka dne.
dayChanged = false;

// Rychlost herniho casu vzhledem k normalnimu.
TIME_SPEED = 2720; // 24h = 2 min

// Maximalni doba otaceni ciferniku.
ROTATION_MAX_INTERVAL = 0.5; // sec

// Doba zobrazeni hlasky na outputu
ECHO_INTERVAL = 3; // s

// cas posledni hlaskz na output
lastEcho = 0;

// Herni datum. Zacina aktualnim datem, ale ubiha TIME_SPEEDx rychleji nez normalni cas.
GameDate = new Date();

/**
 * Singleton pro pocitani a vypis celkoveho casu straveneho ve hre.
 */
TotalTime = new function() {
    this.startTime = null;
    this.d = 0;
    this.h = 0;
    this.m = 0;
    this.s = 0;
    
    this.init = function(time) {
        if (this.startTime == null) {
            this.startTime = time;
        }
    }
    
    this.recount = function(toTime) {
        this.init(toTime);
        diff = (toTime - this.startTime);
        this.d = Math.round(diff / (24*60*60));
        this.h = Math.round((diff / (24*60*60)) % 24);
        this.m = Math.round((diff / (24*60*60)) % 60);
        this.s = Math.round(diff % 60);
    }
    
    this.toString = function() {
        return this.d + " d, " +
                this.h + " h, " +
                this.m + " m, " +
                this.s + " s";
    }
}

/**
 * trida, slouzici k pocitani rotaci pro ciferniky.
 * @param element node ciferniku, se kterou se pracuje.
 * @param speedKoef pocet vterin kolik ubehne, nez se cifernik otoci. Podle
 * tohoto koeficientu se vypocitava rychlost otaceni.
 */
RotationInfo = function(element, speedKoef) {
    this.element = element;
    this.startTime = null;
    this.startAngle = 0;
    this.finalAngle = 0;
    this.lastSet = null;
    this.speedKoef = speedKoef;
    this.element.rotation.angle = 0; // init je na 0
    
    this.getNormalAngle = function(angle) {
        while (angle < 0) {
            angle += 2 * Math.PI;
        }
        
        while (angle >= 2*Math.PI) {
            angle -= 2 * Math.PI;
        }
        
        return angle;
    }
    
    this.getNumber = function() {
//        return this.getNormalAngle(this.element.rotation.angle);
        return (10 - Math.round(10 * (this.getNormalAngle(this.element.rotation.angle)) / (Math.PI * 2))) % 10;
    }
    
    this.countNumberAngle = function(number) {
        return 2 * Math.PI - (number * (Math.PI / 5));
    }
    
    this.setRotation = function(toNumber, actualTime) {
        if (this.startTime === null && toNumber != this.lastSet) {
            // resetuju si to tak, abych mel uhel v rozmezi <0; 2*PI)
            this.element.rotation.angle = this.getNormalAngle(this.element.rotation.angle);
            
            this.lastSet = toNumber;
            this.startAngle = this.element.rotation.angle;
            this.finalAngle = this.countNumberAngle(toNumber);
            if (Math.abs(this.finalAngle - this.startAngle) > Math.PI) {
                this.finalAngle -= 2 * Math.PI;
            }
            this.startTime = actualTime;
        }
    }
    
    this.rotate = function(time) {
        if (this.startTime == null) {
            return;
        }
        
        rotationInterval = Math.min(ROTATION_MAX_INTERVAL, this.speedKoef * (1/(2*TIME_SPEED)));
        
        if (time-this.startTime >= rotationInterval) {
            this.element.rotation.angle = this.finalAngle;
            this.startTime = null;
            return;
        }
        
        koef = ((time-this.startTime) / rotationInterval);
        this.element.rotation.angle = this.startAngle + (koef * (this.finalAngle - this.startAngle));
    }
}

// Rotacni tridy pro ciferniky minuty.
minutesRotation = new Array(
    new RotationInfo(minute_1, 60*10),
    new RotationInfo(minute_2, 60)
);

// Rotacni tridy pro ciferniky hodiny.
hoursRotation = new Array(
    new RotationInfo(hour_1, 60*60*10),
    new RotationInfo(hour_2, 60*60)
);

// Rotacni tridy pro ciferniky dne.
daysRotation = new Array(
    new RotationInfo(day_1, 60*60*24),
    new RotationInfo(day_2, 60*60*24)
);

// Rotacni tridy pro ciferniky mesice.
monthsRotation = new Array(
    new RotationInfo(month_1, 60*60*24),
    new RotationInfo(month_2, 60*60*24)
);

// Rotacni tridy pro ciferniky roku.
yearsRotation = new Array(
    new RotationInfo(year_1, 60*60*24),
    new RotationInfo(year_2, 60*60*24),
    new RotationInfo(year_3, 60*60*24),
    new RotationInfo(year_4, 60*60*24)
);

// Posledni value (pokrok v rozmezi 0..1) timeru, pro ktery byla zavolana funkce set_date.
lastVal = 0;

/**
 * input func
 */
function set_date(val, time) {
    TotalTime.recount(time);
    
    if (cas) {
        updateDate(val);
        if (dayChanged) {
            updateDayLength();
        }
        
        setLight(time);
    }
    
    // nulovani zpravy po vyprseni timeoutu
    if (HUDInfo.string[0] != "" && time - lastEcho > ECHO_INTERVAL) {
        HUDInfo.string[0] = "";
    }
    
    // hodiny nastavuju porad, protoze i pri zastavenem case potrebuju dojet rotaci.
    setClock(time);
    
    lastVal = val;
}

function getDayInYear(month, day) {
    var sum = 0;
    for (var a=0; a<month; a++) {
        sum += DAYS_IN_MONTH[a];
    }
    sum += day;
    return sum;
}

function updateDayLength() {
    var dayPerc = getDayInYear(GameDate.getMonth(), GameDate.getDate()) / 365;
    var riseDiff = MIN_SUN_HOURS[0] - MAX_SUN_HOURS[0];
    var setDiff = MAX_SUN_HOURS[1] - MIN_SUN_HOURS[1];
    
    TOTAL_DARK_INTERVAL[0] = MIN_SUN_HOURS[1] + (setDiff * Math.sin(Math.PI * dayPerc)) + (SUNRISE_DURATION / 2);
    TOTAL_LIGHT_INTERVAL[1] = MIN_SUN_HOURS[1] + (setDiff * Math.sin(Math.PI * dayPerc)) - (SUNRISE_DURATION / 2);
    
    TOTAL_DARK_INTERVAL[1] = MIN_SUN_HOURS[0] - (riseDiff * Math.sin(Math.PI * dayPerc)) - (SUNRISE_DURATION / 2);
    TOTAL_LIGHT_INTERVAL[0] = MIN_SUN_HOURS[0] - (riseDiff * Math.sin(Math.PI * dayPerc)) + (SUNRISE_DURATION / 2);
    
//    HUDInfo.string[0] = "dayperc: " + dayPerc + " / " +
//            "DARK: " + Math.round(TOTAL_DARK_INTERVAL[0]) + "-" + Math.round(TOTAL_DARK_INTERVAL[1]) +
//            " / LIGHT: " + Math.round(TOTAL_LIGHT_INTERVAL[0]) + "-" + Math.round(TOTAL_LIGHT_INTERVAL[1]);
}

function isTimeInInterval(min, max) {
    var tmp = GameDate.getHours() + (GameDate.getMinutes()/60);
    if (max > min) {
        return (tmp >= min && tmp < max);
    } else {
        // pro prechod kolem pulnoci
        return (tmp >= min || tmp < max);
    }
}

/**
 * Nastavi zmeny svetla.
 */
function setLight(time) {
    var intensity = 0;
    var intensityDiff;
    var diff;
    var tmp;
    
    // pokud je velka tma
    if (isTimeInInterval(TOTAL_DARK_INTERVAL[0], TOTAL_DARK_INTERVAL[1])) {
        diff = (24 - (TOTAL_DARK_INTERVAL[0] - TOTAL_DARK_INTERVAL[1])) * 60;
        tmp = ((((GameDate.getHours() < TOTAL_DARK_INTERVAL[0]) ? (GameDate.getHours() + 24) : GameDate.getHours()) - TOTAL_DARK_INTERVAL[0]) * 60) + GameDate.getMinutes();
        intensityDiff = TOTAL_DARK_KOEF[1] - TOTAL_DARK_KOEF[0];
        intensity = TOTAL_DARK_KOEF[1] - (Math.sin(Math.PI * tmp / diff) * intensityDiff);
//        HUDInfo.string[0] = "DARK / diff: " + diff + " / tmp: " + tmp + " / intentity: " + intensity;
    }
    
    // pokud je hodmne svetla
    if (isTimeInInterval(TOTAL_LIGHT_INTERVAL[0], TOTAL_LIGHT_INTERVAL[1])) {
        diff = (TOTAL_LIGHT_INTERVAL[1] - TOTAL_LIGHT_INTERVAL[0]) * 60;
        tmp = ((GameDate.getHours() - TOTAL_LIGHT_INTERVAL[0]) * 60) + GameDate.getMinutes();
        intensityDiff = TOTAL_LIGHT_KOEF[0] - TOTAL_LIGHT_KOEF[1];
        intensity = TOTAL_LIGHT_KOEF[1] + (Math.sin(Math.PI * tmp / diff) * intensityDiff);
//        HUDInfo.string[0] = "LIGHT / diff: " + diff + " / tmp: " + tmp + " / intentity: " + intensity;
    }
    
    // dopoledne
    if (isTimeInInterval(TOTAL_DARK_INTERVAL[1], TOTAL_LIGHT_INTERVAL[0])) {
        diff = (TOTAL_LIGHT_INTERVAL[0] - TOTAL_DARK_INTERVAL[1]) * 60;
        tmp = ((GameDate.getHours() - TOTAL_DARK_INTERVAL[1]) * 60) + GameDate.getMinutes();
        intensityDiff = TOTAL_LIGHT_KOEF[1] - TOTAL_DARK_KOEF[1];
        intensity = TOTAL_DARK_KOEF[1] + ((tmp / diff) * intensityDiff);
//        HUDInfo.string[0] = "DOPOLEDNE / diff: " + diff + " / tmp: " + tmp + " / intentity: " + intensity;
    }
    
    // odpoledne
    if (isTimeInInterval(TOTAL_LIGHT_INTERVAL[1], TOTAL_DARK_INTERVAL[0])) {
        diff = (TOTAL_DARK_INTERVAL[0] - TOTAL_LIGHT_INTERVAL[1]) * 60;
        tmp = ((GameDate.getHours() - TOTAL_LIGHT_INTERVAL[1]) * 60) + GameDate.getMinutes();
        intensityDiff = TOTAL_LIGHT_KOEF[1] - TOTAL_DARK_KOEF[1];
        intensity = TOTAL_LIGHT_KOEF[1] - ((tmp / diff) * intensityDiff);
//        HUDInfo.string[0] = "ODPOLEDNE / diff: " + diff + " / tmp: " + tmp + " / intentity: " + intensity;
    }
    
    intenzita_svetla = intensity;
    
    barva_pozadi[0].r = SKY_DAY[0][0] * intensity;
    barva_pozadi[0].g = SKY_DAY[0][1] * intensity;
    barva_pozadi[0].b = SKY_DAY[0][2] * intensity;
    barva_pozadi[1].r = SKY_DAY[1][0] * intensity;
    barva_pozadi[1].g = SKY_DAY[1][1] * intensity;
    barva_pozadi[1].b = SKY_DAY[1][2] * intensity;
    barva_pozadi[2].r = SKY_DAY[2][0] * intensity;
    barva_pozadi[2].g = SKY_DAY[2][1] * intensity;
    barva_pozadi[2].b = SKY_DAY[2][2] * intensity;
    
//    HUDInfo.string[0] = "intenzita svetla: " + intensity;
}

/**
 * Zajistuje soupani s hodinami.
 */
function setClock(time) {
    hoursRotation[0].setRotation(Math.floor(GameDate.getHours()/10), time);
    hoursRotation[1].setRotation(GameDate.getHours()%10, time);
    minutesRotation[0].setRotation(Math.floor(GameDate.getMinutes()/10), time);
    minutesRotation[1].setRotation(GameDate.getMinutes()%10, time);
    daysRotation[0].setRotation(Math.floor(GameDate.getDate()/10), time);
    daysRotation[1].setRotation(GameDate.getDate()%10, time);
    monthsRotation[0].setRotation(Math.floor((GameDate.getMonth()+1)/10), time);
    monthsRotation[1].setRotation((GameDate.getMonth()+1)%10, time);
    yearsRotation[0].setRotation(Math.floor((GameDate.getYear()+1900)/1000) % 10, time);
    yearsRotation[1].setRotation(Math.floor((GameDate.getYear()+1900)/100) % 10, time);
    yearsRotation[2].setRotation(Math.floor((GameDate.getYear()+1900)/10) % 10, time);
    yearsRotation[3].setRotation((GameDate.getYear()+1900)%10, time);
    
    hoursRotation[0].rotate(time);
    hoursRotation[1].rotate(time);
    minutesRotation[0].rotate(time);
    minutesRotation[1].rotate(time);
    daysRotation[0].rotate(time);
    daysRotation[1].rotate(time);
    monthsRotation[0].rotate(time);
    monthsRotation[1].rotate(time);
    yearsRotation[0].rotate(time);
    yearsRotation[1].rotate(time);
    yearsRotation[2].rotate(time);
    yearsRotation[3].rotate(time);
}

/**
 * Upravi datum podle toho, jak se timer posunul a v zavislosti na konstante
 * rychlosti casu.
 */
function updateDate(val) {
    var previousDay = GameDate.getDate();
    
    diff = (val < lastVal) ? (val + 1 - lastVal) : (val - lastVal);

    GameDate.setTime(GameDate.getTime() + (diff * 1000 * TIME_SPEED));
    
    dayChanged = (previousDay != GameDate.getDate())
}

function set_md_click(val, time) {
    mesto_duchu = !mesto_duchu;
    updateValue(mesto_duchu, "Město duchů", TlacitkoMD, time);
}

function set_sipky_click(val, time) {
    sipky = (sipky == 0) ? 1 : 0;
    updateValue(sipky == 1, "Šipky", TlacitkoSipky, time);
}

function set_cas_click(val, time) {
    cas = !cas;
    updateValue(cas, "Běh času", null, time);
}

function set_lod_click(val, time) {
    lod = (lod == 0) ? 1 : 0;
    updateValue(lod == 1, "LOD", TlacitkoLOD, time);
}

function updateValue(value, title, object, time) {
    setEcho(title + ": " + (value == true ? "zap." : "vyp."), time);
    
    if (object != null) {
        if (!value) {
            object.appearance.material.diffuseColor.r = 1;
            object.appearance.material.diffuseColor.g = 0.5;
            object.appearance.material.diffuseColor.b = 0.5;
            object.appearance.material.emissiveColor.r = 0.6;
            object.appearance.material.emissiveColor.g = 0.3;
            object.appearance.material.emissiveColor.b = 0.3;
        } else {
            object.appearance.material.diffuseColor.r = 0.5;
            object.appearance.material.diffuseColor.g = 1;
            object.appearance.material.diffuseColor.b = 0.5;
            object.appearance.material.emissiveColor.r = 0.3;
            object.appearance.material.emissiveColor.g = 0.6;
            object.appearance.material.emissiveColor.b = 0.3;
        }
    }
}

function setEcho(echo, time) {
    lastEcho = time;
    HUDInfo.string[0] = echo;
}

set_md_click();
set_sipky_click();
set_cas_click();
set_lod_click();

updateDayLength();

setLight();